//testgraph.cpp

#include "graph.h"

#include <iostream>
using namespace std;

int main()
{
	int node; 
	int flag;
	char alg;

	cout << "Anzahl Knoten: " << flush;
	cin >> node;
	cout << "Flag (Zufall=0, Eingabe=1): " << flush;
	cin >> flag;
	
	Graph g(node, flag);
	g.print();
	g.print_graphviz_notation();
	alg='d';
	while (alg!='e')
	{
		cout << "Algorithmus (TOPSORT=t,BFS=b,DFS=d,Ende=e): " 
			<< flush;
		cin >> alg;
		switch (alg)
		{
			case 't': 
				cout << "topologisches Sortieren" << endl;
				g.topsort();
				break;
			case 'b': 
				cout << "Breitensuche" << endl;
				cout << "BFS-Startknoten: " << flush;
				cin >> node;
				g.bfs(node);
				break;
			case 'd': 
				cout << "Tiefensuche" << endl;
				g.dfs();
				break;
			case 'e':
				break;
			default: 
				cout << "nicht implementiert" << endl;
				break;
		}
	}
		
	return 0;
}

