//queue.cpp

#include "queue.h"

#include <iostream>
using namespace std;

bool Queue::isEmpty() const
{
	if (tail == head)
		return true;
	else
		return false;
}

bool Queue::isFull() const
{
	if (tail == head - 1 || (head == 0 && tail == MAX_ELE-1) )
	{
		return true;
	}
	else
	{
		return false;
	}
}

bool Queue::enqueue(int k)
{
	if (isFull())
	{
		return false;
	}else
	{
		a[tail] = k;
		tail++;
		if (tail == MAX_ELE)
		{
			tail = 0;
		}
		return true;
	}
}

bool Queue::dequeue(int &x)
{
	if (isEmpty() )
	{
		return false;
	}else
	{
		x = a[head];
		a[head] = PLATZHALTER;
		head++;
		if (head == MAX_ELE)
		{
			head = 0;
		}
		return true;
	}
}

void Queue::print() const
{
	for (int i = 0; i < MAX_ELE; i++)
	{
		cout << a[i] << ' ';
	}
	cout << endl
	     << "head: " << head << " = " << a[head] << endl
	     << "tail: " << tail << " = " <<a[tail] << endl;
}


