//list.cpp

#include "list.h"

#include <iostream>
using namespace std;


ListElement* List::insert (int k)
{
	ListElement* p = new ListElement;
	if (p == 0)
	{
		return p;
	}
	p->key = k;
	p->next = head;
	head = p;
	length++;
	return p;
}

ListElement* List::search(int k)
{
	ListElement* p = head;
	
	while (p != 0)
	{
		p = p->next;
	}
	
	return p;
}

bool List::remove(int k)
{
	ListElement* p1 = head;
	ListElement* p2 = head;	
	
	int i = 0;
	while (p1 != 0 && p1->key != k)
	{
		i++;
		
		p2 = p1;
		
		p1 = p1->next;
	}
	
	if (p1 == 0)
	{
		return false;
	}else
	{
		
		if (p1 == head)
		{
			cout << p1->key << endl;
			head = p1->next;
		}else
		{
			p2->next = p1->next;
		}
		delete p1;
		length--;
		return true;
	}
}

void List::print() const
{
	ListElement* p = head;
	cout << "-> ";
	
	while (p != 0)
	{
		cout << p->key << " -> ";
		p = p->next;
	}
	
	cout << "NULL" << endl;;
}

ListElement*List:: getHead() const
{
	return head;
}




